IMPLEMENTATION MODULE Procs;

 (* File: Procs.mod  Author: Michael F. Bisignani June 89 *)
 
FROM Cglobals IMPORT  BIGINT, ct ;     (*  VARIABLES *)
FROM Support IMPORT idle,CallExit,EnterCriticalSection,
                LeaveCriticalSection,UseSharedData;
(*----------------------------------------------*)
PROCEDURE process1;
BEGIN
  ct[1] := 0;  
  LOOP
   IF ct[1] < BIGINT 
    THEN  INC(ct[1]);
    ELSE  EXIT  END;  
 END;
 CallExit(1);
END process1;
(*---------------------------------------------*)
PROCEDURE process2;
BEGIN
 ct[2] := 0;
 LOOP
   EnterCriticalSection(2);
   UseSharedData;
   idle(10000); (* Slow This One Down A Bit *)
   idle(10000); (* Before Leaving CS  *)
   LeaveCriticalSection;
   IF ct[2] < BIGINT
    THEN  ct[2] := ct[2]+ 1;
    ELSE  EXIT  END;
    idle(10000);  (*   Waste SomeTime *)
 END;
 CallExit(2);
END process2;
(*----------------------------------------------*)
PROCEDURE process3;
BEGIN
 ct[3] := 0;
 WHILE ct[3] < 200 DO 
    INC(ct[3]);
    EnterCriticalSection(3);
    UseSharedData;
    LeaveCriticalSection;
 END;
 CallExit(3);
END process3;
END  Procs.
